
:- module('ex_intneg_05', _).

% Loops (WFS has to take care of it).
a :- a.
b :- intneg(b).

c :- d.
d :- c.

e :- intneg(f).
f :- intneg(e).

p1(X) :- p1(X).
p2(X) :- intneg(p2(X)).

p3(X) :- p4(X).
p4(X) :- p3(X).

p5(X) :- intneg(p6(X)).
p6(X) :- intneg(p5(X)).

% Loop with values to get results.
p7(X) :- intneg(q7(X)).
q7(X) :- intneg(p7(X)).

p7(1).
q7(2).

% WFS has to be used by forall.
g :- p8(X).
p8(X) :- g.

h :- p9(X).
p9(1).

i :- p9(X), intneg(p9(X)).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

test_fail_01 :- a.
test_fail_02 :- b.
test_fail_02 :- intneg(b).
test_fail_03 :- c.
test_fail_04 :- e.
test_fail_05 :- intneg(e).

test_fail_11 :- p1(X).
test_fail_12 :- p2(X).
test_fail_13 :- intneg(p2(X)).
test_fail_14 :- p3(X).
test_fail_15 :- p5(X).
test_fail_16 :- intneg(p5(X)).

test_fail_21 :- g(X).
test_fail_22 :- intneg(h).
test_fail_22 :- i.

test_ok_01 :- intneg(a).
test_ok_02 :- intneg(c).

test_ok_11 :- intneg(p1(X)).
test_ok_12 :- intneg(p3(X)).
test_ok_13(X) :- p7(X). % X = 1
test_ok_14(X) :- intneg(p7(X)). % X = 2

% Try to fire the bug of not having history in forall for wfs.
test_ok_21(X) :- intneg(g).
test_ok_22 :- h.
test_ok_23 :- intneg(i).

